﻿// <copyright file="UserInfo.cs" company="Redpoint Apps">
// Copyright (c) Redpoint Apps. All rights reserved.
// </copyright>

namespace RedPoint.ReefStatus.Common.ProfiLux
{
    using System;

    /// <summary>
    /// User Info
    /// </summary>
    public class UserInfo : BaseInfo
    {
        /// <summary>
        /// Gets the double value.
        /// </summary>
        /// <value>The double value.</value>
        public override double DoubleValue
        {
            get { return this.Value != null ? (double)this.Value : 0; }
        }

        public override object ConvertedValue
        {
            get { return this.Value; }
        }

        private DateTime time;

        /// <summary>
        /// Gets or sets the time.
        /// </summary>
        /// <value>The time.</value>
        public DateTime Time
        {
            get { return time; }
            set
            {
                time = value;
                OnPropertyChanged("Time");
            }
        }
    }
}
