﻿namespace RedPoint.ReefStatus.Gui.ViewModels
{
    using Common.Core;
    using System;
    using System.Collections.ObjectModel;
    using System.Windows.Threading;
    using RedPoint.ReefStatus.Common.UI.ViewModel;
    using RedPoint.ReefStatus.Common;

    public class ErrorLogViewModel : ViewModelBase
    {
        private readonly Dispatcher dispatcher;

        public static ErrorLogViewModel Instance { get; private set; }

        public ObservableCollection<LogMessage> ErrorLogContent { get; private set; }

        /// <summary>
        /// Initializes the <see cref="ErrorLogViewModel"/> class.
        /// </summary>
        static ErrorLogViewModel()
        {
            Instance = new ErrorLogViewModel();
        }

        /// <summary>
        /// Starups this instance.
        /// </summary>
        public static void Starup()
        {
        }

        private ErrorLogViewModel()
        {
            dispatcher = Dispatcher.CurrentDispatcher;
            ErrorLogContent = new ObservableCollection<LogMessage>();
            Logger.Instance.OnError += this.LoggerOnError;
        }

        /// <summary>
        /// Loggers the on error.
        /// </summary>
        /// <param name="message">The message.</param>
        private void LoggerOnError(LogMessage message)
        {
            if (!dispatcher.CheckAccess())
            {
                dispatcher.BeginInvoke(new Action(()=>LoggerOnError(message)));
            }
            else
            {
                ErrorLogContent.Add(message);
                if (ErrorLogContent.Count > 200)
                {
                    ErrorLogContent.RemoveAt(0);
                }
            }
        }
    }
}
