﻿using RedPoint.ReefStatus.Common.UI.ViewModel;
using System.Windows.Input;

namespace RedPoint.ReefStatus.Gui.ViewModels
{
    using RedPoint.ReefStatus.Common.ProfiLux;

    public class ThunderViewModel : ViewModelBase
    {
        private ICommand thunderStormCommand;
        private int duration = 5;

        public ThunderViewModel(Controler controler)
        {
            Controler = controler;
        }

        public Controler Controler { get; private set; }

        /// <summary>
        /// Gets the thunder storm command.
        /// </summary>
        /// <value>The thunder storm command.</value>
        public ICommand ThunderStormCommand
        {
            get
            {
                if (thunderStormCommand == null)
                {
                    thunderStormCommand = new DelegateCommand(ThunderStorm);
                }
                return thunderStormCommand;
            }
        }

        /// <summary>
        /// Gets or sets the duration.
        /// </summary>
        /// <value>The duration.</value>
        public int Duration
        {
            set 
            { 
                duration = value;
                OnPropertyChanged("Duration");
            }
            get { return duration; }
        }

        /// <summary>
        /// Thunders the storm.
        /// </summary>
        private void ThunderStorm()
        {
            this.Controler.Commands.ThunderStorm(Duration);
        }
    }
}
