﻿namespace RedPoint.ReefStatus.Gui.Views
{
    using System.Windows;
    using System.Windows.Forms;
    using Common.ProfiLux;

    /// <summary>
    /// Interaction logic for DataSettingsView.xaml
    /// </summary>
    public partial class DataSettingsView
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DataSettingsView"/> class.
        /// </summary>
        public DataSettingsView()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Handles the Click event of the ColourButton control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.RoutedEventArgs"/> instance containing the event data.</param>
        private void ColourButton_Click(object sender, RoutedEventArgs e)
        {
            BaseInfo info = DataContext as BaseInfo;
            if (info == null)
            {
                return;
            }

            ColorDialog dialog = new ColorDialog { Color = info.Colour };

            if (dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                System.Drawing.Color color = dialog.Color;
                info.Colour = color;
            }
        }

        /// <summary>
        /// Handles the Click event of the CloseButton control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.RoutedEventArgs"/> instance containing the event data.</param>
        private void CloseButton_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }
    }
}
