﻿namespace RedPoint.ReefStatus.Gui.Views
{
    using System.Windows;
    using Common.Settings;
    using RedPoint.ReefStatus.Common.Core;

    /// <summary>
    /// Interaction logic for OptionsView.xaml
    /// </summary>
    public partial class OptionsView
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OptionsView"/> class.
        /// </summary>
        public OptionsView()
        {
            InitializeComponent();
            DataContext = ReefStatusSettings.Instance;
        }

        /// <summary>
        /// Handles the Click event of the Button control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.RoutedEventArgs"/> instance containing the event data.</param>
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void Window_Closed(object sender, System.EventArgs e)
        {
            DataService.Instance.UpdateSettings();
        }
    }
}
