﻿// <copyright file="CustomGraph.cs" company="Redpoint Apps">
// Copyright (c) Redpoint Apps. All rights reserved.
// </copyright>

namespace RedPoint.ReefStatus
{
    using System;
    using System.Collections.Generic;
    using System.Collections.ObjectModel;
    using System.Windows.Forms;

    using RedPoint.ReefStatus.Common.ProfiLux;

    /// <summary>
    /// Custom Graph
    /// </summary>
    public partial class CustomGraph : Form
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CustomGraph"/> class.
        /// </summary>
        /// <param name="parent">The parent.</param>
        public CustomGraph(Form parent)
        {
            InitializeComponent();
            panel1.Setup();
            MdiParent = parent;
        }

        /// <summary>
        /// Adds the point.
        /// </summary>
        /// <param name="item">The item.</param>
        /// <param name="date">The date.</param>
        /// <param name="value">The value.</param>
        public void AddPoint(BaseInfo item, DateTime date, double value)
        {
            panel1.AddPoint(item.Id, date, value, item.Controler);
        }

        /// <summary>
        /// Adds the points to the graph.
        /// </summary>
        /// <param name="points">The points.</param>
        /// <param name="controler">The controler.</param>
        public void AddPoints(Dictionary<string, Collection<Common.ProfiLux.DataPoint>> points, Controler controler)
        {
            panel1.AddPoints(points, true, controler);
        }
    }
}