﻿// <copyright file="ErrorLog.cs" company="Redpoint Apps">
// Copyright (c) Redpoint Apps. All rights reserved.
// </copyright>

namespace RedPoint.ReefStatus
{
    using System;
    using System.Windows.Forms;
    using RedPoint.ReefStatus.Common;

    /// <summary>
    /// The Error Log window
    /// </summary>
    public partial class ErrorLog : Form
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ErrorLog"/> class.
        /// </summary>
        public ErrorLog()
        {
            InitializeComponent();
            Text = "Log";
        }

        /// <summary>
        /// The text for the control
        /// </summary>
        /// <value>The text for the control</value>
        /// <returns>The text associated with this control.</returns>
        public override sealed string Text
        {
            get { return base.Text; }
            set { base.Text = value; }
        }

        /// <summary>
        /// Logs the specified text.
        /// </summary>
        /// <param name="message">The message.</param>
        public void LogError(string message)
        {
            errorList.Items.Add(DateTime.Now + " " + message);
            if (errorList.Items.Count > 200)
            {
                errorList.Items.RemoveAt(0);
            }
        }
    }
}