﻿using System.Windows;
using System.Windows.Input;
using RedPoint.ReefStatus.Common;
using RedPoint.ReefStatus.Common.Settings;
using RedPoint.ReefStatus.Common.UI.ViewModel;

namespace Redpoint.ReefStatus.ScreenSaver
{
    public class SettingsViewModel : ViewModelBase
    {
        /// <summary>
        /// Gets the settings.
        /// </summary>
        /// <value>The settings.</value>
        public ReefStatusSettings Settings
        {
            get { return ReefStatusSettings.Instance; }
        }

        /// <summary>
        /// Gets or sets the close command.
        /// </summary>
        /// <value>The close command.</value>
        public ICommand CloseCommand { get; private set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="SettingsViewModel"/> class.
        /// </summary>
        public SettingsViewModel()
        {
            CloseCommand = new DelegateCommand(Close);
        }

        /// <summary>
        /// Closes this instance.
        /// </summary>
        private void Close()
        {
            this.Settings.Save();
            Application.Current.Shutdown();
        }
    }
}
