﻿namespace RedPoint.ReefStatus
{
    using System;
    using System.Globalization;
    using System.Security.Permissions;
    using System.Windows;
    using Common;
    using Common.Localization;

    public partial class App
    {
        [SecurityPermission(SecurityAction.Demand, Flags = SecurityPermissionFlag.ControlAppDomain)]
        protected override void OnStartup(StartupEventArgs e)
        {
            AppDomain.CurrentDomain.AssemblyResolve += CurrentDomain_AssemblyResolve;

            AppExceptionHandler.Handle();
            base.OnStartup(e);

            try
            {
                ResourceLoader.LoadFileResources(Current.Resources.MergedDictionaries, CultureInfo.CurrentCulture.Name);
            }
            catch (Exception)
            {
                // TODO: Log the exception
            }


        }
        static System.Reflection.Assembly CurrentDomain_AssemblyResolve(object sender, ResolveEventArgs args)
        {
            if (args.Name.StartsWith("System.Data.SQLite, ", StringComparison.OrdinalIgnoreCase))
            {
                string realName = IntPtr.Size == 8 ? "x64/System.Data.SQLite.dll" : "System.Data.SQLite.dll";
                return System.Reflection.Assembly.LoadFile(realName);
            }

            return null;
        }

        private void Application_Startup(object sender, StartupEventArgs e)
        {
            System.Windows.Forms.Application.EnableVisualStyles();
            System.Windows.Forms.Application.SetCompatibleTextRenderingDefault(false);
            System.Windows.Forms.Application.Run(new ReefStatusFrame());
        }
    }
}
